﻿using System;
using Microsoft.EntityFrameworkCore;
using System.ComponentModel.DataAnnotations;
using System.Collections.Generic;

namespace Schedule.Model
{
    public partial class ScheduleDataContext : DbContext
    {
        public ScheduleDataContext(DbContextOptions<ScheduleDataContext> options)
            : base(options)
        { }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<DefaultSchedule>(entity =>
            {
                entity.Property(e => e.Id).IsRequired();
            });

        }
        public virtual DbSet<DefaultSchedule> DefaultSchedule { get; set; }
    }

    public class DefaultSchedule
    {
        [Key]
        public int Id { get; set; }
        public string Subject { get; set; }
        public bool AllDay { get; set; }
        public bool Recurrence { get; set; }
        public DateTime StartTime { get; set; }
        public DateTime EndTime { get; set; }
        public string Description { get; set; }
        public string RecurrenceRule { get; set; }
    }

    public class EditParams
    {
        public string key { get; set; }
        public string action { get; set; }
        public List<DefaultSchedule> added { get; set; }
        public List<DefaultSchedule> changed { get; set; }
        public List<DefaultSchedule> deleted { get; set; }
        public DefaultSchedule value { get; set; }
    }
}
